
/*
	C++ filter plugin.
	This uses the new, somewhat experimental, SoundPlay C++
	plugin API.
	This API basically mimics the regular API, except it uses
	C++ classes.
	Functions that you don't need can simply be left unimplemented,
	SoundPlay will automatically know that they are not implemented.
*/

#include "CPlusAPI.h"
#include "pluginproto.h"

class MyFilter: public FilterPlugin
{
	public:
		MyFilter()
		{
		}

		status_t FilterShort(short *buffer,int32 framecount, void *info)
		{
			for(int i=0;i<framecount;i++)
			{
				int left=buffer[0]-buffer[1];
				int right=buffer[1]-buffer[0];
				if(left<-32768)
					left=-32768;
				else if(left>32767)
					left=32767;
				
				if(right<-32768)
					right=-32768;
				else if(right>32767)
					right=32767;
				
				buffer[0]=left;
				buffer[1]=right;
				
				buffer+=2;
 			}
			return B_OK;
		}

//		status_t FilterFloat(float **input, float **output, int32 framecount, void *info)
//		{
//		}

		void 	FileChange(const char *name, const char *path)
		{
		}

		BView*	Configure()
		{
			return NULL;
		}
		
		void	SetConfig(BMessage *config)
		{
		}
		
		void	GetConfig(BMessage *config)
		{
		}
};

class MyPluginFactory: public PluginFactory
{
	public:
		MyPluginFactory()
		{
		}
		
		char *ID()
		{
			return "novoice++";
		}
		
		uint32 Flags()
		{
			return PLUGIN_IS_FILTER;
		}

		char *Name()
		{
			return "C++ Voice Eliminator";
		}

		virtual const char*	AboutString()
		{
			return "By Marco Nelissen.\n";
		}

//		void About()
//		{
//			BAlert *alert=new BAlert("About Voice Eliminator plugin",
//				"Voice Eliminator plugin.\n"
//				"By Marco Nelissen.\n",
//				"OK");
//			alert->SetFeel(B_NORMAL_WINDOW_FEEL);
//			alert->Go(NULL);
//		}

//		BView *Configure(BMessage *config)
//		{
//			return NULL;
//		}
		
		Plugin* CreatePlugin(const char *name, const char *header, uint32 size, plugin_info *pluginfo)
		{
			return new MyFilter;;
		}
};


status_t GetPluginFactories(BList *out_list)
{
	out_list->AddItem(new MyPluginFactory);
	return B_OK;
}
